<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/hex-0.4.3/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../hex/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../hex/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../hex/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
</pre><pre class="rust"><code><span class="comment">// Copyright (c) 2013-2014 The Rust Project Developers.</span>
<span class="comment">// Copyright (c) 2015-2020 The rust-hex Developers.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// http://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or http://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>
<span class="doccomment">//! Encoding and decoding hex strings.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! For most cases, you can simply use the [`decode`], [`encode`] and</span>
<span class="doccomment">//! [`encode_upper`] functions. If you need a bit more control, use the traits</span>
<span class="doccomment">//! [`ToHex`] and [`FromHex`] instead.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! # #[cfg(not(feature = &quot;alloc&quot;))]</span>
<span class="doccomment">//! # let mut output = [0; 0x18];</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # #[cfg(not(feature = &quot;alloc&quot;))]</span>
<span class="doccomment">//! # hex::encode_to_slice(b&quot;Hello world!&quot;, &amp;mut output).unwrap();</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # #[cfg(not(feature = &quot;alloc&quot;))]</span>
<span class="doccomment">//! # let hex_string = ::core::str::from_utf8(&amp;output).unwrap();</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # #[cfg(feature = &quot;alloc&quot;)]</span>
<span class="doccomment">//! let hex_string = hex::encode(&quot;Hello world!&quot;);</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! println!(&quot;{}&quot;, hex_string); // Prints &quot;48656c6c6f20776f726c6421&quot;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # assert_eq!(hex_string, &quot;48656c6c6f20776f726c6421&quot;);</span>
<span class="doccomment">//! ```</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/hex/0.4.3&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>), <span class="ident">no_std</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">docsrs</span>, <span class="ident">feature</span>(<span class="ident">doc_cfg</span>))]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::unreadable_literal</span>)]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">alloc</span>::{<span class="ident">string::String</span>, <span class="ident">vec::Vec</span>};

<span class="kw">use</span> <span class="ident">core::iter</span>;

<span class="kw">mod</span> <span class="ident">error</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::error::FromHexError</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;serde&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">docsrs</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;serde&quot;</span>)))]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">serde</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;serde&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::serde::deserialize</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;serde&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::serde</span>::{<span class="ident">serialize</span>, <span class="ident">serialize_upper</span>};

<span class="doccomment">/// Encoding values as hex string.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is implemented for all `T` which implement `AsRef&lt;[u8]&gt;`. This</span>
<span class="doccomment">/// includes `String`, `str`, `Vec&lt;u8&gt;` and `[u8]`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use hex::ToHex;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// println!(&quot;{}&quot;, &quot;Hello world!&quot;.encode_hex::&lt;String&gt;());</span>
<span class="doccomment">/// # assert_eq!(&quot;Hello world!&quot;.encode_hex::&lt;String&gt;(), &quot;48656c6c6f20776f726c6421&quot;.to_string());</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *Note*: instead of using this trait, you might want to use [`encode()`].</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">ToHex</span> {
    <span class="doccomment">/// Encode the hex strict representing `self` into the result. Lower case</span>
    <span class="doccomment">/// letters are used (e.g. `f9b4ca`)</span>
    <span class="kw">fn</span> <span class="ident">encode_hex</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">iter::FromIterator</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">T</span>;

    <span class="doccomment">/// Encode the hex strict representing `self` into the result. Upper case</span>
    <span class="doccomment">/// letters are used (e.g. `F9B4CA`)</span>
    <span class="kw">fn</span> <span class="ident">encode_hex_upper</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">iter::FromIterator</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">T</span>;
}

<span class="kw">const</span> <span class="ident">HEX_CHARS_LOWER</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>; <span class="number">16</span>] <span class="op">=</span> <span class="string">b&quot;0123456789abcdef&quot;</span>;
<span class="kw">const</span> <span class="ident">HEX_CHARS_UPPER</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>; <span class="number">16</span>] <span class="op">=</span> <span class="string">b&quot;0123456789ABCDEF&quot;</span>;

<span class="kw">struct</span> <span class="ident">BytesToHexChars</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">inner</span>: <span class="ident">::core::slice::Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">u8</span><span class="op">&gt;</span>,
    <span class="ident">table</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [<span class="ident">u8</span>; <span class="number">16</span>],
    <span class="ident">next</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">BytesToHexChars</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">inner</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>], <span class="ident">table</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [<span class="ident">u8</span>; <span class="number">16</span>]) -&gt; <span class="ident">BytesToHexChars</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="ident">BytesToHexChars</span> {
            <span class="ident">inner</span>: <span class="ident">inner</span>.<span class="ident">iter</span>(),
            <span class="ident">table</span>,
            <span class="ident">next</span>: <span class="prelude-val">None</span>,
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">BytesToHexChars</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">char</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Item</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">next</span>.<span class="ident">take</span>() {
            <span class="prelude-val">Some</span>(<span class="ident">current</span>) =&gt; <span class="prelude-val">Some</span>(<span class="ident">current</span>),
            <span class="prelude-val">None</span> =&gt; <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">next</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">byte</span><span class="op">|</span> {
                <span class="kw">let</span> <span class="ident">current</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">table</span>[(<span class="ident">byte</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">4</span>) <span class="kw">as</span> <span class="ident">usize</span>] <span class="kw">as</span> <span class="ident">char</span>;
                <span class="self">self</span>.<span class="ident">next</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="self">self</span>.<span class="ident">table</span>[(<span class="ident">byte</span> <span class="op">&amp;</span> <span class="number">0x0F</span>) <span class="kw">as</span> <span class="ident">usize</span>] <span class="kw">as</span> <span class="ident">char</span>);
                <span class="ident">current</span>
            }),
        }
    }

    <span class="kw">fn</span> <span class="ident">size_hint</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; (<span class="ident">usize</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) {
        <span class="kw">let</span> <span class="ident">length</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">len</span>();
        (<span class="ident">length</span>, <span class="prelude-val">Some</span>(<span class="ident">length</span>))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">iter::ExactSizeIterator</span> <span class="kw">for</span> <span class="ident">BytesToHexChars</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">length</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span>;
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">next</span>.<span class="ident">is_some</span>() {
            <span class="ident">length</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="ident">length</span>
    }
}

<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">fn</span> <span class="ident">encode_to_iter</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">iter::FromIterator</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">table</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [<span class="ident">u8</span>; <span class="number">16</span>], <span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">T</span> {
    <span class="ident">BytesToHexChars::new</span>(<span class="ident">source</span>, <span class="ident">table</span>).<span class="ident">collect</span>()
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span> <span class="ident">ToHex</span> <span class="kw">for</span> <span class="ident">T</span> {
    <span class="kw">fn</span> <span class="ident">encode_hex</span><span class="op">&lt;</span><span class="ident">U</span>: <span class="ident">iter::FromIterator</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">U</span> {
        <span class="ident">encode_to_iter</span>(<span class="ident">HEX_CHARS_LOWER</span>, <span class="self">self</span>.<span class="ident">as_ref</span>())
    }

    <span class="kw">fn</span> <span class="ident">encode_hex_upper</span><span class="op">&lt;</span><span class="ident">U</span>: <span class="ident">iter::FromIterator</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">U</span> {
        <span class="ident">encode_to_iter</span>(<span class="ident">HEX_CHARS_UPPER</span>, <span class="self">self</span>.<span class="ident">as_ref</span>())
    }
}

<span class="doccomment">/// Types that can be decoded from a hex string.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is implemented for `Vec&lt;u8&gt;` and small `u8`-arrays.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use core::str;</span>
<span class="doccomment">/// use hex::FromHex;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let buffer = &lt;[u8; 12]&gt;::from_hex(&quot;48656c6c6f20776f726c6421&quot;)?;</span>
<span class="doccomment">/// let string = str::from_utf8(&amp;buffer).expect(&quot;invalid buffer length&quot;);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// println!(&quot;{}&quot;, string); // prints &quot;Hello world!&quot;</span>
<span class="doccomment">/// # assert_eq!(&quot;Hello world!&quot;, string);</span>
<span class="doccomment">/// # Ok::&lt;(), hex::FromHexError&gt;(())</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">FromHex</span>: <span class="ident">Sized</span> {
    <span class="kw">type</span> <span class="ident">Error</span>;

    <span class="doccomment">/// Creates an instance of type `Self` from the given hex string, or fails</span>
    <span class="doccomment">/// with a custom error type.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Both, upper and lower case characters are valid and can even be</span>
    <span class="doccomment">/// mixed (e.g. `f9b4ca`, `F9B4CA` and `f9B4Ca` are all valid strings).</span>
    <span class="kw">fn</span> <span class="ident">from_hex</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">hex</span>: <span class="ident">T</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident"><span class="self">Self</span>::Error</span><span class="op">&gt;</span>;
}

<span class="kw">fn</span> <span class="ident">val</span>(<span class="ident">c</span>: <span class="ident">u8</span>, <span class="ident">idx</span>: <span class="ident">usize</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u8</span>, <span class="ident">FromHexError</span><span class="op">&gt;</span> {
    <span class="kw">match</span> <span class="ident">c</span> {
        <span class="string">b&#39;A&#39;</span>..<span class="op">=</span><span class="string">b&#39;F&#39;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">c</span> <span class="op">-</span> <span class="string">b&#39;A&#39;</span> <span class="op">+</span> <span class="number">10</span>),
        <span class="string">b&#39;a&#39;</span>..<span class="op">=</span><span class="string">b&#39;f&#39;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">c</span> <span class="op">-</span> <span class="string">b&#39;a&#39;</span> <span class="op">+</span> <span class="number">10</span>),
        <span class="string">b&#39;0&#39;</span>..<span class="op">=</span><span class="string">b&#39;9&#39;</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">c</span> <span class="op">-</span> <span class="string">b&#39;0&#39;</span>),
        <span class="kw">_</span> =&gt; <span class="prelude-val">Err</span>(<span class="ident">FromHexError::InvalidHexCharacter</span> {
            <span class="ident">c</span>: <span class="ident">c</span> <span class="kw">as</span> <span class="ident">char</span>,
            <span class="ident">index</span>: <span class="ident">idx</span>,
        }),
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">FromHex</span> <span class="kw">for</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Error</span> <span class="op">=</span> <span class="ident">FromHexError</span>;

    <span class="kw">fn</span> <span class="ident">from_hex</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">hex</span>: <span class="ident">T</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident"><span class="self">Self</span>::Error</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">hex</span> <span class="op">=</span> <span class="ident">hex</span>.<span class="ident">as_ref</span>();
        <span class="kw">if</span> <span class="ident">hex</span>.<span class="ident">len</span>() <span class="op">%</span> <span class="number">2</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">FromHexError::OddLength</span>);
        }

        <span class="ident">hex</span>.<span class="ident">chunks</span>(<span class="number">2</span>)
            .<span class="ident">enumerate</span>()
            .<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">pair</span>)<span class="op">|</span> <span class="prelude-val">Ok</span>(<span class="ident">val</span>(<span class="ident">pair</span>[<span class="number">0</span>], <span class="number">2</span> <span class="op">*</span> <span class="ident">i</span>)<span class="question-mark">?</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">4</span> <span class="op">|</span> <span class="ident">val</span>(<span class="ident">pair</span>[<span class="number">1</span>], <span class="number">2</span> <span class="op">*</span> <span class="ident">i</span> <span class="op">+</span> <span class="number">1</span>)<span class="question-mark">?</span>))
            .<span class="ident">collect</span>()
    }
}

<span class="comment">// Helper macro to implement the trait for a few fixed sized arrays. Once Rust</span>
<span class="comment">// has type level integers, this should be removed.</span>
<span class="macro">macro_rules!</span> <span class="ident">from_hex_array_impl</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">len</span>:<span class="ident">expr</span>)<span class="op">+</span>) =&gt; {$(
        <span class="kw">impl</span> <span class="ident">FromHex</span> <span class="kw">for</span> [<span class="ident">u8</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">len</span>] {
            <span class="kw">type</span> <span class="ident">Error</span> <span class="op">=</span> <span class="ident">FromHexError</span>;

            <span class="kw">fn</span> <span class="ident">from_hex</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">hex</span>: <span class="ident">T</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident"><span class="self">Self</span>::Error</span><span class="op">&gt;</span> {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out</span> <span class="op">=</span> [<span class="number">0_u8</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">len</span>];
                <span class="ident">decode_to_slice</span>(<span class="ident">hex</span>, <span class="kw-2">&amp;mut</span> <span class="ident">out</span> <span class="kw">as</span> <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>])<span class="question-mark">?</span>;
                <span class="prelude-val">Ok</span>(<span class="ident">out</span>)
            }
        }
    )<span class="op">+</span>}
}

<span class="macro">from_hex_array_impl!</span> {
    <span class="number">1</span> <span class="number">2</span> <span class="number">3</span> <span class="number">4</span> <span class="number">5</span> <span class="number">6</span> <span class="number">7</span> <span class="number">8</span> <span class="number">9</span> <span class="number">10</span> <span class="number">11</span> <span class="number">12</span> <span class="number">13</span> <span class="number">14</span> <span class="number">15</span> <span class="number">16</span>
    <span class="number">17</span> <span class="number">18</span> <span class="number">19</span> <span class="number">20</span> <span class="number">21</span> <span class="number">22</span> <span class="number">23</span> <span class="number">24</span> <span class="number">25</span> <span class="number">26</span> <span class="number">27</span> <span class="number">28</span> <span class="number">29</span> <span class="number">30</span> <span class="number">31</span> <span class="number">32</span>
    <span class="number">33</span> <span class="number">34</span> <span class="number">35</span> <span class="number">36</span> <span class="number">37</span> <span class="number">38</span> <span class="number">39</span> <span class="number">40</span> <span class="number">41</span> <span class="number">42</span> <span class="number">43</span> <span class="number">44</span> <span class="number">45</span> <span class="number">46</span> <span class="number">47</span> <span class="number">48</span>
    <span class="number">49</span> <span class="number">50</span> <span class="number">51</span> <span class="number">52</span> <span class="number">53</span> <span class="number">54</span> <span class="number">55</span> <span class="number">56</span> <span class="number">57</span> <span class="number">58</span> <span class="number">59</span> <span class="number">60</span> <span class="number">61</span> <span class="number">62</span> <span class="number">63</span> <span class="number">64</span>
    <span class="number">65</span> <span class="number">66</span> <span class="number">67</span> <span class="number">68</span> <span class="number">69</span> <span class="number">70</span> <span class="number">71</span> <span class="number">72</span> <span class="number">73</span> <span class="number">74</span> <span class="number">75</span> <span class="number">76</span> <span class="number">77</span> <span class="number">78</span> <span class="number">79</span> <span class="number">80</span>
    <span class="number">81</span> <span class="number">82</span> <span class="number">83</span> <span class="number">84</span> <span class="number">85</span> <span class="number">86</span> <span class="number">87</span> <span class="number">88</span> <span class="number">89</span> <span class="number">90</span> <span class="number">91</span> <span class="number">92</span> <span class="number">93</span> <span class="number">94</span> <span class="number">95</span> <span class="number">96</span>
    <span class="number">97</span> <span class="number">98</span> <span class="number">99</span> <span class="number">100</span> <span class="number">101</span> <span class="number">102</span> <span class="number">103</span> <span class="number">104</span> <span class="number">105</span> <span class="number">106</span> <span class="number">107</span> <span class="number">108</span> <span class="number">109</span> <span class="number">110</span> <span class="number">111</span> <span class="number">112</span>
    <span class="number">113</span> <span class="number">114</span> <span class="number">115</span> <span class="number">116</span> <span class="number">117</span> <span class="number">118</span> <span class="number">119</span> <span class="number">120</span> <span class="number">121</span> <span class="number">122</span> <span class="number">123</span> <span class="number">124</span> <span class="number">125</span> <span class="number">126</span> <span class="number">127</span> <span class="number">128</span>
    <span class="number">160</span> <span class="number">192</span> <span class="number">200</span> <span class="number">224</span> <span class="number">256</span> <span class="number">384</span> <span class="number">512</span> <span class="number">768</span> <span class="number">1024</span> <span class="number">2048</span> <span class="number">4096</span> <span class="number">8192</span> <span class="number">16384</span> <span class="number">32768</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>))]</span>
<span class="macro">from_hex_array_impl!</span> {
    <span class="number">65536</span> <span class="number">131072</span> <span class="number">262144</span> <span class="number">524288</span> <span class="number">1048576</span> <span class="number">2097152</span> <span class="number">4194304</span> <span class="number">8388608</span>
    <span class="number">16777216</span> <span class="number">33554432</span> <span class="number">67108864</span> <span class="number">134217728</span> <span class="number">268435456</span> <span class="number">536870912</span>
    <span class="number">1073741824</span> <span class="number">2147483648</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>)]</span>
<span class="macro">from_hex_array_impl!</span> {
    <span class="number">4294967296</span>
}

<span class="doccomment">/// Encodes `data` as hex string using lowercase characters.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Lowercase characters are used (e.g. `f9b4ca`). The resulting string&#39;s</span>
<span class="doccomment">/// length is always even, each byte in `data` is always encoded using two hex</span>
<span class="doccomment">/// digits. Thus, the resulting string contains exactly twice as many bytes as</span>
<span class="doccomment">/// the input data.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// assert_eq!(hex::encode(&quot;Hello world!&quot;), &quot;48656c6c6f20776f726c6421&quot;);</span>
<span class="doccomment">/// assert_eq!(hex::encode(vec![1, 2, 3, 15, 16]), &quot;0102030f10&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">must_use</span>]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">T</span>) -&gt; <span class="ident">String</span> {
    <span class="ident">data</span>.<span class="ident">encode_hex</span>()
}

<span class="doccomment">/// Encodes `data` as hex string using uppercase characters.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Apart from the characters&#39; casing, this works exactly like `encode()`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// assert_eq!(hex::encode_upper(&quot;Hello world!&quot;), &quot;48656C6C6F20776F726C6421&quot;);</span>
<span class="doccomment">/// assert_eq!(hex::encode_upper(vec![1, 2, 3, 15, 16]), &quot;0102030F10&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">must_use</span>]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode_upper</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">T</span>) -&gt; <span class="ident">String</span> {
    <span class="ident">data</span>.<span class="ident">encode_hex_upper</span>()
}

<span class="doccomment">/// Decodes a hex string into raw bytes.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Both, upper and lower case characters are valid in the input string and can</span>
<span class="doccomment">/// even be mixed (e.g. `f9b4ca`, `F9B4CA` and `f9B4Ca` are all valid strings).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// assert_eq!(</span>
<span class="doccomment">///     hex::decode(&quot;48656c6c6f20776f726c6421&quot;),</span>
<span class="doccomment">///     Ok(&quot;Hello world!&quot;.to_owned().into_bytes())</span>
<span class="doccomment">/// );</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(hex::decode(&quot;123&quot;), Err(hex::FromHexError::OddLength));</span>
<span class="doccomment">/// assert!(hex::decode(&quot;foo&quot;).is_err());</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">T</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, <span class="ident">FromHexError</span><span class="op">&gt;</span> {
    <span class="ident">FromHex::from_hex</span>(<span class="ident">data</span>)
}

<span class="doccomment">/// Decode a hex string into a mutable bytes slice.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Both, upper and lower case characters are valid in the input string and can</span>
<span class="doccomment">/// even be mixed (e.g. `f9b4ca`, `F9B4CA` and `f9B4Ca` are all valid strings).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// let mut bytes = [0u8; 4];</span>
<span class="doccomment">/// assert_eq!(hex::decode_to_slice(&quot;6b697769&quot;, &amp;mut bytes as &amp;mut [u8]), Ok(()));</span>
<span class="doccomment">/// assert_eq!(&amp;bytes, b&quot;kiwi&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_to_slice</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">T</span>, <span class="ident">out</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">FromHexError</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">as_ref</span>();

    <span class="kw">if</span> <span class="ident">data</span>.<span class="ident">len</span>() <span class="op">%</span> <span class="number">2</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">FromHexError::OddLength</span>);
    }
    <span class="kw">if</span> <span class="ident">data</span>.<span class="ident">len</span>() <span class="op">/</span> <span class="number">2</span> <span class="op">!</span><span class="op">=</span> <span class="ident">out</span>.<span class="ident">len</span>() {
        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">FromHexError::InvalidStringLength</span>);
    }

    <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">byte</span>) <span class="kw">in</span> <span class="ident">out</span>.<span class="ident">iter_mut</span>().<span class="ident">enumerate</span>() {
        <span class="kw-2">*</span><span class="ident">byte</span> <span class="op">=</span> <span class="ident">val</span>(<span class="ident">data</span>[<span class="number">2</span> <span class="op">*</span> <span class="ident">i</span>], <span class="number">2</span> <span class="op">*</span> <span class="ident">i</span>)<span class="question-mark">?</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">4</span> <span class="op">|</span> <span class="ident">val</span>(<span class="ident">data</span>[<span class="number">2</span> <span class="op">*</span> <span class="ident">i</span> <span class="op">+</span> <span class="number">1</span>], <span class="number">2</span> <span class="op">*</span> <span class="ident">i</span> <span class="op">+</span> <span class="number">1</span>)<span class="question-mark">?</span>;
    }

    <span class="prelude-val">Ok</span>(())
}

<span class="comment">// generates an iterator like this</span>
<span class="comment">// (0, 1)</span>
<span class="comment">// (2, 3)</span>
<span class="comment">// (4, 5)</span>
<span class="comment">// (6, 7)</span>
<span class="comment">// ...</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">fn</span> <span class="ident">generate_iter</span>(<span class="ident">len</span>: <span class="ident">usize</span>) -&gt; <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> (<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span> {
    (<span class="number">0</span>..<span class="ident">len</span>).<span class="ident">step_by</span>(<span class="number">2</span>).<span class="ident">zip</span>((<span class="number">0</span>..<span class="ident">len</span>).<span class="ident">skip</span>(<span class="number">1</span>).<span class="ident">step_by</span>(<span class="number">2</span>))
}

<span class="comment">// the inverse of `val`.</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="attribute">#[<span class="ident">must_use</span>]</span>
<span class="kw">fn</span> <span class="ident">byte2hex</span>(<span class="ident">byte</span>: <span class="ident">u8</span>, <span class="ident">table</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>; <span class="number">16</span>]) -&gt; (<span class="ident">u8</span>, <span class="ident">u8</span>) {
    <span class="kw">let</span> <span class="ident">high</span> <span class="op">=</span> <span class="ident">table</span>[((<span class="ident">byte</span> <span class="op">&amp;</span> <span class="number">0xf0</span>) <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">4</span>) <span class="kw">as</span> <span class="ident">usize</span>];
    <span class="kw">let</span> <span class="ident">low</span> <span class="op">=</span> <span class="ident">table</span>[(<span class="ident">byte</span> <span class="op">&amp;</span> <span class="number">0x0f</span>) <span class="kw">as</span> <span class="ident">usize</span>];

    (<span class="ident">high</span>, <span class="ident">low</span>)
}

<span class="doccomment">/// Encodes some bytes into a mutable slice of bytes.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The output buffer, has to be able to hold at least `input.len() * 2` bytes,</span>
<span class="doccomment">/// otherwise this function will return an error.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use hex::FromHexError;</span>
<span class="doccomment">/// # fn main() -&gt; Result&lt;(), FromHexError&gt; {</span>
<span class="doccomment">/// let mut bytes = [0u8; 4 * 2];</span>
<span class="doccomment">///</span>
<span class="doccomment">/// hex::encode_to_slice(b&quot;kiwi&quot;, &amp;mut bytes)?;</span>
<span class="doccomment">/// assert_eq!(&amp;bytes, b&quot;6b697769&quot;);</span>
<span class="doccomment">/// # Ok(())</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode_to_slice</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">input</span>: <span class="ident">T</span>, <span class="ident">output</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">FromHexError</span><span class="op">&gt;</span> {
    <span class="kw">if</span> <span class="ident">input</span>.<span class="ident">as_ref</span>().<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span> <span class="op">!</span><span class="op">=</span> <span class="ident">output</span>.<span class="ident">len</span>() {
        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">FromHexError::InvalidStringLength</span>);
    }

    <span class="kw">for</span> (<span class="ident">byte</span>, (<span class="ident">i</span>, <span class="ident">j</span>)) <span class="kw">in</span> <span class="ident">input</span>
        .<span class="ident">as_ref</span>()
        .<span class="ident">iter</span>()
        .<span class="ident">zip</span>(<span class="ident">generate_iter</span>(<span class="ident">input</span>.<span class="ident">as_ref</span>().<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span>))
    {
        <span class="kw">let</span> (<span class="ident">high</span>, <span class="ident">low</span>) <span class="op">=</span> <span class="ident">byte2hex</span>(<span class="kw-2">*</span><span class="ident">byte</span>, <span class="ident">HEX_CHARS_LOWER</span>);
        <span class="ident">output</span>[<span class="ident">i</span>] <span class="op">=</span> <span class="ident">high</span>;
        <span class="ident">output</span>[<span class="ident">j</span>] <span class="op">=</span> <span class="ident">low</span>;
    }

    <span class="prelude-val">Ok</span>(())
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">use</span> <span class="ident">alloc::string::ToString</span>;
    <span class="kw">use</span> <span class="ident">pretty_assertions::assert_eq</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_gen_iter</span>() {
        <span class="kw">let</span> <span class="ident">result</span> <span class="op">=</span> <span class="macro">vec!</span>[(<span class="number">0</span>, <span class="number">1</span>), (<span class="number">2</span>, <span class="number">3</span>)];

        <span class="macro">assert_eq!</span>(<span class="ident">generate_iter</span>(<span class="number">5</span>).<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>(), <span class="ident">result</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_encode_to_slice</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">output_1</span> <span class="op">=</span> [<span class="number">0</span>; <span class="number">4</span> <span class="op">*</span> <span class="number">2</span>];
        <span class="ident">encode_to_slice</span>(<span class="string">b&quot;kiwi&quot;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">output_1</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">output_1</span>, <span class="string">b&quot;6b697769&quot;</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">output_2</span> <span class="op">=</span> [<span class="number">0</span>; <span class="number">5</span> <span class="op">*</span> <span class="number">2</span>];
        <span class="ident">encode_to_slice</span>(<span class="string">b&quot;kiwis&quot;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">output_2</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">output_2</span>, <span class="string">b&quot;6b69776973&quot;</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">output_3</span> <span class="op">=</span> [<span class="number">0</span>; <span class="number">100</span>];

        <span class="macro">assert_eq!</span>(
            <span class="ident">encode_to_slice</span>(<span class="string">b&quot;kiwis&quot;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">output_3</span>),
            <span class="prelude-val">Err</span>(<span class="ident">FromHexError::InvalidStringLength</span>)
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_decode_to_slice</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">output_1</span> <span class="op">=</span> [<span class="number">0</span>; <span class="number">4</span>];
        <span class="ident">decode_to_slice</span>(<span class="string">b&quot;6b697769&quot;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">output_1</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">output_1</span>, <span class="string">b&quot;kiwi&quot;</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">output_2</span> <span class="op">=</span> [<span class="number">0</span>; <span class="number">5</span>];
        <span class="ident">decode_to_slice</span>(<span class="string">b&quot;6b69776973&quot;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">output_2</span>).<span class="ident">unwrap</span>();
        <span class="macro">assert_eq!</span>(<span class="kw-2">&amp;</span><span class="ident">output_2</span>, <span class="string">b&quot;kiwis&quot;</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">output_3</span> <span class="op">=</span> [<span class="number">0</span>; <span class="number">4</span>];

        <span class="macro">assert_eq!</span>(
            <span class="ident">decode_to_slice</span>(<span class="string">b&quot;6&quot;</span>, <span class="kw-2">&amp;mut</span> <span class="ident">output_3</span>),
            <span class="prelude-val">Err</span>(<span class="ident">FromHexError::OddLength</span>)
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_encode</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">encode</span>(<span class="string">&quot;foobar&quot;</span>), <span class="string">&quot;666f6f626172&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_decode</span>() {
        <span class="macro">assert_eq!</span>(
            <span class="ident">decode</span>(<span class="string">&quot;666f6f626172&quot;</span>),
            <span class="prelude-val">Ok</span>(<span class="ident">String::from</span>(<span class="string">&quot;foobar&quot;</span>).<span class="ident">into_bytes</span>())
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_from_hex_okay_str</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">Vec::from_hex</span>(<span class="string">&quot;666f6f626172&quot;</span>).<span class="ident">unwrap</span>(), <span class="string">b&quot;foobar&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">Vec::from_hex</span>(<span class="string">&quot;666F6F626172&quot;</span>).<span class="ident">unwrap</span>(), <span class="string">b&quot;foobar&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_from_hex_okay_bytes</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">Vec::from_hex</span>(<span class="string">b&quot;666f6f626172&quot;</span>).<span class="ident">unwrap</span>(), <span class="string">b&quot;foobar&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">Vec::from_hex</span>(<span class="string">b&quot;666F6F626172&quot;</span>).<span class="ident">unwrap</span>(), <span class="string">b&quot;foobar&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_invalid_length</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">Vec::from_hex</span>(<span class="string">&quot;1&quot;</span>).<span class="ident">unwrap_err</span>(), <span class="ident">FromHexError::OddLength</span>);
        <span class="macro">assert_eq!</span>(
            <span class="ident">Vec::from_hex</span>(<span class="string">&quot;666f6f6261721&quot;</span>).<span class="ident">unwrap_err</span>(),
            <span class="ident">FromHexError::OddLength</span>
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_invalid_char</span>() {
        <span class="macro">assert_eq!</span>(
            <span class="ident">Vec::from_hex</span>(<span class="string">&quot;66ag&quot;</span>).<span class="ident">unwrap_err</span>(),
            <span class="ident">FromHexError::InvalidHexCharacter</span> { <span class="ident">c</span>: <span class="string">&#39;g&#39;</span>, <span class="ident">index</span>: <span class="number">3</span> }
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_empty</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">Vec::from_hex</span>(<span class="string">&quot;&quot;</span>).<span class="ident">unwrap</span>(), <span class="string">b&quot;&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_from_hex_whitespace</span>() {
        <span class="macro">assert_eq!</span>(
            <span class="ident">Vec::from_hex</span>(<span class="string">&quot;666f 6f62617&quot;</span>).<span class="ident">unwrap_err</span>(),
            <span class="ident">FromHexError::InvalidHexCharacter</span> { <span class="ident">c</span>: <span class="string">&#39; &#39;</span>, <span class="ident">index</span>: <span class="number">4</span> }
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">test_from_hex_array</span>() {
        <span class="macro">assert_eq!</span>(
            <span class="op">&lt;</span>[<span class="ident">u8</span>; <span class="number">6</span>] <span class="kw">as</span> <span class="ident">FromHex</span><span class="op">&gt;</span><span class="ident">::from_hex</span>(<span class="string">&quot;666f6f626172&quot;</span>),
            <span class="prelude-val">Ok</span>([<span class="number">0x66</span>, <span class="number">0x6f</span>, <span class="number">0x6f</span>, <span class="number">0x62</span>, <span class="number">0x61</span>, <span class="number">0x72</span>])
        );

        <span class="macro">assert_eq!</span>(
            <span class="op">&lt;</span>[<span class="ident">u8</span>; <span class="number">5</span>] <span class="kw">as</span> <span class="ident">FromHex</span><span class="op">&gt;</span><span class="ident">::from_hex</span>(<span class="string">&quot;666f6f626172&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">FromHexError::InvalidStringLength</span>)
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_to_hex</span>() {
        <span class="macro">assert_eq!</span>(
            [<span class="number">0x66</span>, <span class="number">0x6f</span>, <span class="number">0x6f</span>, <span class="number">0x62</span>, <span class="number">0x61</span>, <span class="number">0x72</span>].<span class="ident">encode_hex</span>::<span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>(),
            <span class="string">&quot;666f6f626172&quot;</span>.<span class="ident">to_string</span>(),
        );

        <span class="macro">assert_eq!</span>(
            [<span class="number">0x66</span>, <span class="number">0x6f</span>, <span class="number">0x6f</span>, <span class="number">0x62</span>, <span class="number">0x61</span>, <span class="number">0x72</span>].<span class="ident">encode_hex_upper</span>::<span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>(),
            <span class="string">&quot;666F6F626172&quot;</span>.<span class="ident">to_string</span>(),
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="hex" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>